/**
 *
 * Written by Ed Hong UWT Feb. 19, 2003
 *
 * @author edhong
 * @version 0.0
 */
import	java.io.*;
import  java.util.*;
import  java.text.*;

class GraphInput{

		/** Loads graph data from text file.
		    asks user for directory and path name.
		    returns hashtable of String, Vertex pairs.
		    newgraph needs to already be initiailized.
		  */
	public static Hashtable LoadSimpleGraph(SimpleGraph newgraph) {
         System.out.print("Please enter the full path and file name for the input data: ");
		  String userinput;
		  userinput = KeyboardReader.readString();
   		  return    LoadSimpleGraph(newgraph, userinput);
	}

			/**
		     * Loads graph data from a text file.
		     * Each line of the file contains 3 tokens, where
		     * first two are strings representing vertex labels and
		     * the third is a double edge weight.
		     * Each line representing one edge..
		     * returns hashtable of String, Vertex pairs.
		     * @param pathandfilename  is the name of the file, including full path.
		     * @param newgraph  is a graph to add edges to. newgraph should already be
		     *          initialized
		     */
	public static Hashtable LoadSimpleGraph(SimpleGraph newgraph, String pathandfilename){
		BufferedReader	inbuf = InputLib.fopen(pathandfilename);
		System.out.println("Opened " + pathandfilename + " for input.");
		String	line = InputLib.getLine(inbuf); // get first line
		StringTokenizer	sTok;
		int n, linenum = 0;
		Hashtable table = new Hashtable();
		SimpleGraph sg = newgraph;

		while (line != null) {
			linenum++;
			sTok = new StringTokenizer(line);
			n = sTok.countTokens();
			if (n==3) {
				Double edgedata;
				Vertex v1, v2;
				String v1name, v2name;

				v1name = sTok.nextToken();
				v2name = sTok.nextToken();
				edgedata = new Double(Double.parseDouble(sTok.nextToken()));
				v1 = (Vertex) table.get(v1name);
				v2 = (Vertex) table.get(v2name);
				if (v1 == null) {
//					    System.out.println("New vertex " + v1name);
						v1 = sg.insertVertex(v1name);
						table.put(v1name, v1);
				}
				if (v2 == null) {
//					    System.out.println("New vertex " + v2name);
					v2 = sg.insertVertex(v2name);
					table.put(v2name, v2);
				}
//				System.out.println("Inserting edge (" + v1name + "," + v2name + ")" + edgedata);
				sg.insertEdge(v1,v2,edgedata);
			}
			else {
			    System.err.println("Error:invalid number of tokens found on line " +linenum+ "!");
			    return null;
			}
			line = InputLib.getLine(inbuf);
		}

		InputLib.fclose(inbuf);
		System.out.println("Successfully loaded "+ linenum + " lines. ");
		return table;
	}


	public static void main (String args[]) {
		  SimpleGraph G;
		  G = new SimpleGraph();
		  LoadSimpleGraph(G,args[0]);
	}
}